/*
 * File:		CExtendDragTask.c
 * Created:		8/1/93
 * Desc:		A mousetask that handles dragging and dropping
 *				in CItemTable.
 *
 * Superclass:	CTableDragger.
 * Uses:		CItemTable, CItem.
 * Original Author:	W. Wesley Monroe
 * Modifications:	Atul Barve
 *
 * Copyright  1993 Animas Software Production. All rights reserved.
 */

#include <CTableDragger.h>

class CItem;
class CItemList;


class CExtendDragTask : public CTableDragger {

protected:

	CItemList	*fSelectedItems;
	CView		*fEnclosingPano;
	CView		*fReleasedView, *fOriginalView;

	Rect		fSelRect;
	Boolean		fGRDrawn;
	Boolean		fFirst;
	Boolean		fDropFlags;

public:

	void IExtendDragTask(CTable *aTable, CView *dragBoundsView,
							short theModifiers,
						    long selFlags);

	virtual void BeginTracking(LongPt *startPt);
	virtual void KeepTracking(LongPt *currPt, LongPt *prevPt, LongPt *startPt);
	virtual void EndTracking(LongPt *currPt, LongPt *prevPt, LongPt *startPt);

	virtual void Dispose(void);
};