/*
 * File:		CItemList.h
 * Created:		7/25/93
 * Desc:		A list of CItems that can initialize itself
 *				from disk.  See CItem for a full description of
 *				what items are.
 *
 * Superclass:	CList.
 * Uses:		CItem.
 * Original Author:	Atul Barve
 * Modifications:	W. Wesley Monroe
 *
 * Copyright  1993 Animas Software Production. All rights reserved.
 */

#pragma once

#include <CList.h>
#include	"CItem.h"


class CItemList : public CList {

public:

	void	IItemList(void);
	void	IItemRes(OSType type);
	CItem	*ReadItem(Handle itemH, short level);

	virtual CItem *MakeItem(void);
	virtual CItemList *CopyList(Boolean copySubItems);

	virtual void RemoveItem(CObject *theObject);
	virtual void RemoveFromVisTree(CObject *theObject);

	void	DeleteItems(void);
/*	void 	Dispose(void);*/
};
