/*
 * File:		CTableExpander.c
 * Created:		8/1/93
 * Desc:		A mousetask that handles drawing the expando icon.
 *
 * Superclass:	CTableDragger.
 * Uses:		CItemTable, CItem.
 * Original Author:	W. Wesley Monroe
 * Modifications:	
 *
 * Copyright  1993 Animas Software Production. All rights reserved.
 */


#include <CTableDragger.h>

class CItem;

class CTableExpander : public CTableDragger {

	CItem	*fSelItem;

	Rect		fIconR; // Rectangle for the expanding icon

	Boolean fInTriangle;	// Is the mouse in the triangle...
	Boolean fInverted;		// Is the triangle currently inverted...

	short	fArrowICNid1, fArrowICNid2, fArrowICNid3;
	short	fIndentLeft, fExpanded;

public:

	void ITableExpander(CTable *aTable, short theModifiers,
					    long selFlags, CItem *item, Rect iconR);

	virtual void BeginTracking(LongPt *startPt);
	virtual void KeepTracking(LongPt *currPt, LongPt *prevPt, LongPt *startPt);
	virtual void EndTracking(LongPt *currPt, LongPt *prevPt, LongPt *startPt);
};