/*
 * File:		CTypingTask.cp
 * Created:		8/10/93
 * Desc:		A task to accumulate characters as the they are typed.
 *
 * Superclass:	CTask.
 * Uses:		CPane.
 *
 * Note:		
 *
 * Original Author:	W. Wesley Monroe
 * Copyright  1993 Animas Software Production. All rights reserved.
 */


#pragma once

#include <CTask.h>

class	CItemTable;

class CTypingTask : public CTask {

	CItemTable	*fTable;
	EventRecord	*fMacEvent;
	
	Boolean		fStillTyping;
	char 		fAccumulatedChars[32];
	long		fStartTicks;

public:

	void ITypingTask(CItemTable *itsTable, short taskIndex);
	virtual void	Dispose(void);

	virtual Boolean CanStillType(void);
	virtual void	CancelTyping(void);
	
	virtual void 	DoTyping(char aChar);
};
